<?php

/*********************************************************************

 新着リンク表示プラグイン (2014/01/27)

  32877|http://32877.xii.jp

*********************************************************************/

/* メイン処理 */
function freo_display_link_recently()
{
	global $freo;

	if ($freo->config['plugin']['link_recently']['default_limit'] == 0) {
		return;
	}

	//検索条件設定
	$category_id = false;
		if ($freo->config['plugin']['link_recently']['category_id']) {
			$category_id = true;
		}

	if ($category_id == true){
		$condition = ' WHERE id IS NOT NULL AND category_id =:category_id';
	} else {
		$condition = ' WHERE id IS NOT NULL OR category_id =:category_id';
	}

	//リンク取得
	$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_links ' . $condition . ' ORDER BY id DESC LIMIT :limit');
	$stmt->bindValue(':limit', intval($freo->config['plugin']['link_recently']['default_limit']), PDO::PARAM_INT);
	$stmt->bindvalue(':category_id', $freo->config['plugin']['link_recently']['category_id']);
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	$plugin_links = array();
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$plugin_links[$data['id']] = $data;
	}

	//リンクID取得
	$plugin_link_keys = array_keys($plugin_links);

	//リンクタグ取得
	$plugin_link_tags = array();
	foreach ($plugin_link_keys as $plugin_link) {
		if (!$plugin_links[$plugin_link]['tag']) {
			continue;
		}

		$plugin_link_tags[$plugin_link] = explode(',', $plugin_links[$plugin_link]['tag']);
	}

	//ファイル取得
	$plugin_link_files = array();
	foreach ($plugin_link_keys as $plugin_link) {
		$file_dir = FREO_FILE_DIR . 'plugins/link_files/' . $plugin_link . '/';

		if (file_exists($file_dir)) {
			if ($dir = scandir($file_dir)) {
				foreach ($dir as $data) {
					if (is_file($file_dir . $data) and preg_match("/(\w+)\.\w+$/", $data, $matches)) {
						$plugin_link_files[$plugin_link][$matches[1]] = $data;
					}
				}
			} else {
				freo_error('ファイル保存ディレクトリを開けません。');
			}
		}
	}

	//データ割当
	$freo->smarty->assign(array(
		'plugin_link_recentries'          => $plugin_links,
		'plugin_link_recently_tags'       => $plugin_link_tags,
		'plugin_link_recently_files'      => $plugin_link_files
	));

	return;
}

?>
